package tools.site;

import java.net.MalformedURLException;

import com.sun.star.beans.PropertyValue;
import com.sun.star.comp.helper.BootstrapException;
import com.sun.star.frame.XComponentLoader;
import com.sun.star.frame.XStorable;
import com.sun.star.io.IOException;
import com.sun.star.lang.IllegalArgumentException;
import com.sun.star.lang.XComponent;
import com.sun.star.lang.XMultiComponentFactory;
import com.sun.star.uno.Exception;
import com.sun.star.uno.UnoRuntime;
import com.sun.star.uno.XComponentContext;
import com.sun.star.util.CloseVetoException;
import com.sun.star.util.XCloseable;

/*
 * This program HAS WORKED but now before I send it to you I check it and it does not work any more :
 * 
com.sun.star.task.ErrorCodeIOException: 
	at com.sun.star.lib.uno.environments.remote.Job.remoteUnoRequestRaisedException(Job.java:187)
	at com.sun.star.lib.uno.environments.remote.Job.execute(Job.java:153)
	at com.sun.star.lib.uno.environments.remote.JobQueue.enter(JobQueue.java:349)
	at com.sun.star.lib.uno.environments.remote.JobQueue.enter(JobQueue.java:318)
	at com.sun.star.lib.uno.environments.remote.JavaThreadPool.enter(JavaThreadPool.java:106)
	at com.sun.star.lib.uno.bridges.java_remote.java_remote_bridge.sendRequest(java_remote_bridge.java:657)
	at com.sun.star.lib.uno.bridges.java_remote.ProxyFactory$Handler.request(ProxyFactory.java:159)
	at com.sun.star.lib.uno.bridges.java_remote.ProxyFactory$Handler.invoke(ProxyFactory.java:141)
	at $Proxy6.storeToURL(Unknown Source)
	at housetools.site.HtmlToPdf.convertir(HtmlToPdf.java:98)
	
	I have seen some similar issues on the web, but I cannot get rid of it quickly before sending it to you
*/
/*
 * 
 * Besides I think you are right about OO not using a jvm, because when I run again this program from Eclipse
 * after a test, it says "HtmlToPdf already running". So I kill the java task, and its ready to run. So the pending 
 * java task should be mine.
 * 
 */
/*
 * The referenced lib are : juh jurt ridl unoil from OO 2.3
 * 
 */

public class HtmlToPdf {
	
	XComponentContext xContext = null;
	XMultiComponentFactory xMCF = null;
	Object oDesktop = null;
    XComponentLoader xCompLoader = null;
    PropertyValue propertyValues[] = null;
	XStorable xStorable = null;
	XCloseable xCloseable = null;
	// different tests :
	boolean trace = true;
	boolean eclipse = true;
    
	public static void main(String[] args) {
		new HtmlToPdf();
	}

	HtmlToPdf() {
        try {
        	// ATTENTION : il faut que OO soit lanc !!!
			// get the remote office component context (OO listens on 8100)
			xContext = com.sun.star.comp.helper.Bootstrap.bootstrap();
			if(trace) System.out.println("Connected to a running office ...");

			// get the remote office service manager
			xMCF = xContext.getServiceManager();
			
			// get the Desktop service
			oDesktop = xMCF.createInstanceWithContext("com.sun.star.frame.Desktop", xContext);
			//(Object <> XDesktop, qui est un de ses interfaces !!!)
   
			// get the component loader interface of Desktop service
			xCompLoader = (XComponentLoader) UnoRuntime.queryInterface(XComponentLoader.class, oDesktop);
			
		} catch (BootstrapException e) {
			e.printStackTrace();
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		if (eclipse) { // self-test, without the client calling "convertir"
			String path_in = "facture3.html";
			String path_out = "facture3.pdf";
			convertir(path_in, path_out);
		}
	}
	
	
	void convertir(String path_in, String path_out) {
        try {
			// Loading the wanted document
			propertyValues = new PropertyValue[2];
			propertyValues[0] = new PropertyValue();
			propertyValues[0].Name = "Hidden"; // H uppercase 
			propertyValues[0].Value = new Boolean(true); // boolean !!!
			propertyValues[1] = new PropertyValue();
			propertyValues[1].Name = "FilterName"; 
			propertyValues[1].Value = "HTML"; // unless: you just get the source html as result
			
			String url_in = createUNOFileURL(path_in);
			XComponent xDoc = xCompLoader.loadComponentFromURL(url_in, "_blank", 0, propertyValues);
			
			// Getting an interface that will offer a simple way to store *this* document to a URL.
			xStorable = (XStorable)UnoRuntime.queryInterface(XStorable.class, xDoc );
			
			// Preparing properties for converting the document
			propertyValues = new PropertyValue[2];
			// Setting the filter name
			propertyValues[0] = new PropertyValue();
			propertyValues[0].Name = "FilterName";
			propertyValues[0].Value = "writer_pdf_Export"; // E uppercase
			// Setting the overwrite flag 
			propertyValues[1] = new PropertyValue();
			propertyValues[1].Name = "Overwrite"; // unless: it crashes
			propertyValues[1].Value = new Boolean(true);
			
			// Storing and converting the document
			String url_out = createUNOFileURL(path_out);
			xStorable.storeToURL(url_out, propertyValues); // export, NOT persistence ==> "ToURL"

		} catch (IOException e) {
			System.out.println(e.getCause());
			e.printStackTrace();
		} catch (IllegalArgumentException e) {
			e.printStackTrace();
		} finally {
			// Closing the converted document
			xCloseable = (XCloseable)UnoRuntime.queryInterface(XCloseable.class, xStorable);
			if ( xCloseable != null ) { // Use XCloseable.close if the interface is supported
				try {
					xCloseable.close(false); // dont give ownership to other for closing
					if(trace) System.out.println("close xStorable");
				} catch (CloseVetoException e) {
					e.printStackTrace();
				}
			} else { // otherwise use XComponent.dispose
			    XComponent xComp = (XComponent)UnoRuntime.queryInterface(XComponent.class, xStorable);
			    xComp.dispose();
			    if(trace) System.out.println("dispose xStorable");
			}
		}
		if(trace) System.out.println("fin de convertir");
	}
	
	
	// this is a try to close or dispose most things...
	// it is called by "client" test only
	void terminate() {
		// Closing the desktop ?!
		xCloseable = (XCloseable)UnoRuntime.queryInterface(XCloseable.class, oDesktop);
		if ( xCloseable != null ) { // Use XCloseable.close if the interface is supported
			try {
				xCloseable.close(false); // dont give ownership to other for closing
				if(trace) System.out.println("close oDesktop");
			} catch (CloseVetoException e) {
				e.printStackTrace();
			}
		} else { // otherwise use XComponent.dispose
			XComponent xComp = (XComponent)UnoRuntime.queryInterface(XComponent.class, oDesktop);
			xComp.dispose(); // ATTENTION !!! sinon javaw reste ouvert dans OO + le fichier en read-only !!!
			if(trace) System.out.println("dispose oDesktop");
		}
		
		// Closing the service manager ?!
		xCloseable = (XCloseable)UnoRuntime.queryInterface(XCloseable.class, xMCF);
		if ( xCloseable != null ) { // Use XCloseable.close if the interface is supported
			try {
				xCloseable.close(false); // dont give ownership to other for closing
				if(trace) System.out.println("close xMCF");
			} catch (CloseVetoException e) {
				e.printStackTrace();
			}
		} else { // otherwise use XComponent.dispose
			XComponent xComp = (XComponent)UnoRuntime.queryInterface(XComponent.class, xMCF);
			xComp.dispose(); // ATTENTION !!! sinon javaw reste ouvert dans OO + le fichier en read-only !!!
			if(trace) System.out.println("dispose xMCF");
		}
		
		// Closing the context ?!
		xCloseable = (XCloseable)UnoRuntime.queryInterface(XCloseable.class, xContext);
		if ( xCloseable != null ) { // Use XCloseable.close if the interface is supported
			try {
				xCloseable.close(false); // dont give ownership to other for closing
				if(trace) System.out.println("close xContext");
			} catch (CloseVetoException e) {
				e.printStackTrace();
			}
		} else { // otherwise use XComponent.dispose
			XComponent xComp = (XComponent)UnoRuntime.queryInterface(XComponent.class, xContext);
			xComp.dispose(); // ATTENTION !!! sinon javaw reste ouvert dans OO + le fichier en read-only !!!
			if(trace) System.out.println("dispose xContext");
		}
		if(trace) System.out.println("fin de HtmlToPdf");
	}
	
	
    // Create a correct File URL that OpenOffice can handle. This is necessary to be platform independent.
    String createUNOFileURL(String filelocation)
    {
        java.io.File newfile = new java.io.File(filelocation);
        java.net.URL before = null;
        try
        {
            before = newfile.toURI().toURL();
        }
        catch (MalformedURLException e) {
            System.out.println(e);
        }
        if (before == null) return null;
        // Create a URL, which can be used by UNO
        String myUNOFileURL =  com.sun.star.uri.ExternalUriReferenceTranslator
          .create(xContext).translateToInternal(before.toExternalForm());

        if (myUNOFileURL.length() == 0 && filelocation.length() > 0)
        {
            System.out.println("File URL conversion faild. Filelocation contains illegal characters: " + filelocation);
        }
        if(trace) System.out.println("myUNOFileURL "+myUNOFileURL);
        return myUNOFileURL;
    }
}
